diff -uNrp linux-2.6.14.5/include/asm-i386/system.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/system.h
--- linux-2.6.14.5/include/asm-i386/system.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-i386/system.h	2006-01-22 13:01:14.000000000 +0100
@@ -459,6 +459,51 @@ struct alt_instr { 
 #define set_wmb(var, value) do { var = value; wmb(); } while (0)
 
 /* interrupt control.. */
+#ifdef CONFIG_IPIPE
+
+#include <linux/linkage.h>
+
+void __ipipe_stall_root(void);
+
+void __ipipe_unstall_root(void);
+
+unsigned long __ipipe_test_root(void);
+
+unsigned long __ipipe_test_and_stall_root(void);
+
+void fastcall __ipipe_restore_root(unsigned long flags);
+
+#define local_save_flags(x)	((x) = (!__ipipe_test_root()) << 9)
+#define local_irq_save(x)	((x) = (!__ipipe_test_and_stall_root()) << 9)
+#define local_irq_restore(x)	__ipipe_restore_root(!(x & 0x200))
+#define local_irq_disable()	__ipipe_stall_root()
+#define local_irq_enable()	__ipipe_unstall_root()
+
+#define irqs_disabled()		__ipipe_test_root()
+
+#define safe_halt() do { \
+    __ipipe_unstall_root(); \
+    __asm__ __volatile__("sti; hlt": : :"memory"); \
+} while(0)
+
+#define halt()	__asm__ __volatile__("hlt": : :"memory")
+
+#define ipipe_hw_save_flags_and_sti(x)	__asm__ __volatile__("pushfl ; popl %0 ; sti":"=g" (x): /* no input */ :"memory")
+#define local_irq_disable_hw() 			__asm__ __volatile__("cli": : :"memory")
+#define local_irq_enable_hw()			__asm__ __volatile__("sti": : :"memory")
+#define local_irq_save_hw(x)    __asm__ __volatile__("pushfl ; popl %0 ; cli":"=g" (x): /* no input */ :"memory")
+#define local_irq_restore_hw(x) __asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (x):"memory", "cc")
+#define local_save_flags_hw(x)   __asm__ __volatile__("pushfl ; popl %0":"=g" (x): /* no input */)
+#define local_test_iflag_hw(x)   ((x) & (1<<9))
+#define irqs_disabled_hw()	\
+({					\
+	unsigned long flags;		\
+	local_save_flags_hw(flags);	\
+	!local_test_iflag_hw(flags);	\
+})
+
+#else /* !CONFIG_IPIPE */
+
 #define local_save_flags(x)	do { typecheck(unsigned long,x); __asm__ __volatile__("pushfl ; popl %0":"=g" (x): /* no input */); } while (0)
 #define local_irq_restore(x) 	do { typecheck(unsigned long,x); __asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (x):"memory", "cc"); } while (0)
 #define local_irq_disable() 	__asm__ __volatile__("cli": : :"memory")
@@ -478,6 +523,13 @@ struct alt_instr { 
 /* For spinlocks etc */
 #define local_irq_save(x)	__asm__ __volatile__("pushfl ; popl %0 ; cli":"=g" (x): /* no input */ :"memory")
 
+#define local_irq_save_hw(flags)	local_irq_save(flags)
+#define local_irq_restore_hw(flags)	local_irq_restore(flags)
+#define local_irq_enable_hw()		local_irq_enable()
+#define local_irq_disable_hw(flags)	local_irq_disable()
+
+#endif /* CONFIG_IPIPE */
+
 /*
  * disable hlt during certain critical i/o operations
  */
diff -uNrp linux-2.6.14.5/include/asm-ia64/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-ia64/ltt.h
--- linux-2.6.14.5/include/asm-ia64/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-ia64/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,6 @@
+#ifndef _ASM_IA64_LTT_H
+#define _ASM_IA64_LTT_H
+
+#define LTT_HAS_TSC
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-m32r/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-m32r/ltt.h
--- linux-2.6.14.5/include/asm-m32r/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-m32r/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_M32R_LTT_H
+#define _ASM_M32R_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-m68k/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-m68k/ltt.h
--- linux-2.6.14.5/include/asm-m68k/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-m68k/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_M68K_LTT_H
+#define _ASM_M68K_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-m68knommu/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-m68knommu/ltt.h
--- linux-2.6.14.5/include/asm-m68knommu/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-m68knommu/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_M68KNOMMU_LTT_H
+#define _ASM_M68KNOMMU_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-mips/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-mips/ltt.h
--- linux-2.6.14.5/include/asm-mips/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-mips/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+/*
+ * linux/include/asm-mips/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ *
+ * MIPS definitions for tracing system
+ */
+
+#ifndef _ASM_MIPS_LTT_H
+#define _ASM_MIPS_LTT_H
+
+#define LTT_HAS_TSC
+
+/* Current arch type */
+#define LTT_ARCH_TYPE LTT_ARCH_TYPE_MIPS
+
+/* Current variant type */
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_NONE
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-mips/mipsregs.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-mips/mipsregs.h
--- linux-2.6.14.5/include/asm-mips/mipsregs.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-mips/mipsregs.h	2006-01-22 13:01:14.000000000 +0100
@@ -369,6 +369,7 @@
  */
 #define  CAUSEB_EXCCODE		2
 #define  CAUSEF_EXCCODE		(_ULCAST_(31)  <<  2)
+#define  CAUSE_EXCCODE(cause)	(((cause) & CAUSEF_EXCCODE) >> CAUSEB_EXCCODE)
 #define  CAUSEB_IP		8
 #define  CAUSEF_IP		(_ULCAST_(255) <<  8)
 #define  CAUSEB_IP0		8
diff -uNrp linux-2.6.14.5/include/asm-parisc/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-parisc/ltt.h
--- linux-2.6.14.5/include/asm-parisc/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-parisc/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,6 @@
+#ifndef _ASM_PARISC_LTT_H
+#define _ASM_PARISC_LTT_H
+
+#define LTT_HAS_TSC
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-ppc/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-ppc/ltt.h
--- linux-2.6.14.5/include/asm-ppc/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-ppc/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,35 @@
+/*
+ * linux/include/asm-ppc/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ *
+ * PowerPC definitions for tracing system
+ */
+
+#ifndef _ASM_PPC_LTT_H
+#define _ASM_PPC_LTT_H
+
+#include <linux/config.h>
+
+#define LTT_HAS_TSC
+
+/* Current arch type */
+#define LTT_ARCH_TYPE LTT_ARCH_TYPE_PPC
+
+/* PowerPC variants */
+#define LTT_ARCH_VARIANT_PPC_4xx          1   /* 4xx systems (IBM embedded series) */
+#define LTT_ARCH_VARIANT_PPC_6xx          2   /* 6xx/7xx/74xx/8260/POWER3 systems (desktop flavor) */
+#define LTT_ARCH_VARIANT_PPC_8xx          3   /* 8xx system (Motoral embedded series) */
+#define LTT_ARCH_VARIANT_PPC_ISERIES      4   /* 8xx system (iSeries) */
+
+/* Current variant type */
+#if defined(CONFIG_4xx)
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_PPC_4xx
+#elif defined(CONFIG_6xx)
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_PPC_6xx
+#elif defined(CONFIG_8xx)
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_PPC_8xx
+#elif defined(CONFIG_PPC_ISERIES)
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_PPC_ISERIES
+#endif
+#endif //_ASM_PPC_LTT_H
diff -uNrp linux-2.6.14.5/include/asm-ppc64/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-ppc64/ltt.h
--- linux-2.6.14.5/include/asm-ppc64/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-ppc64/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,6 @@
+#ifndef _ASM_PPC64_LTT_H
+#define _ASM_PPC64_LTT_H
+
+#define LTT_HAS_TSC
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-s390/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-s390/ltt.h
--- linux-2.6.14.5/include/asm-s390/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-s390/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+/*
+ * linux/include/asm-s390/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ *
+ * S/390 definitions for tracing system
+ */
+
+#ifndef _ASM_S390_LTT_H
+#define _ASM_S390_LTT_H
+
+#define LTT_HAS_TSC
+
+/* Current arch type */
+#define LTT_ARCH_TYPE LTT_ARCH_TYPE_S390
+
+/* Current variant type */
+#define LTT_ARCH_VARIANT LTT_ARCH_VARIANT_NONE
+
+#endif//_ASM_S390_LTT_H
diff -uNrp linux-2.6.14.5/include/asm-sh/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sh/ltt.h
--- linux-2.6.14.5/include/asm-sh/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sh/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,14 @@
+/*
+ * linux/include/asm-sh/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ *
+ * SuperH definitions for tracing system
+ */
+
+#ifndef _ASM_SH_LTT_H
+#define _ASM_SH_LTT_H
+
+#include <asm-generic/ltt.h>
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-sh64/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sh64/ltt.h
--- linux-2.6.14.5/include/asm-sh64/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sh64/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,14 @@
+/*
+ * linux/include/asm-sh64/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ *
+ * SuperH definitions for tracing system
+ */
+
+#ifndef _ASM_SH_LTT_H
+#define _ASM_SH_LTT_H
+
+#include <asm-generic/ltt.h>
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-sparc/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sparc/ltt.h
--- linux-2.6.14.5/include/asm-sparc/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sparc/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_SPARC_LTT_H
+#define _ASM_SPARC_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-sparc64/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sparc64/ltt.h
--- linux-2.6.14.5/include/asm-sparc64/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-sparc64/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,15 @@
+#ifndef _ASM_SPARC64_LTT_H
+#define _ASM_SPARC64_LTT_H
+/*
+ * linux/include/asm-sparc64/ltt.h
+ *
+ * Copyright (C) 2005 - Mathiey Desnoyers (mathieu.desnoyers@polymtl.ca)
+ * Copyright (C) 2002, 2003 - Tom Zanussi (zanussi@us.ibm.com), IBM Corp
+ * Copyright (C) 2002 - Karim Yaghmour (karim@opersys.com)
+ *
+ * sparc64 time and TSC definitions for ltt
+ */
+
+#define LTT_HAS_TSC
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-um/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-um/ltt.h
--- linux-2.6.14.5/include/asm-um/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-um/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,13 @@
+/*
+ * linux/include/asm-um/ltt.h
+ *
+ * Copyright (C) 2002, Karim Yaghmour
+ * 
+ */
+
+#ifndef _ASM_SH_LTT_H
+#define _ASM_SH_LTT_H
+
+#include <asm-generic/ltt.h>
+
+#endif
diff -uNrp linux-2.6.14.5/include/asm-v850/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-v850/ltt.h
--- linux-2.6.14.5/include/asm-v850/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-v850/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,5 @@
+#ifndef _ASM_V850_LTT_H
+#define _ASM_V850_LTT_H
+
+#include <asm-generic/ltt.h>
+#endif
diff -uNrp linux-2.6.14.5/include/asm-x86_64/ltt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-x86_64/ltt.h
--- linux-2.6.14.5/include/asm-x86_64/ltt.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/asm-x86_64/ltt.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,6 @@
+#ifndef _ASM_X86_64_LTT_H
+#define _ASM_X86_64_LTT_H
+
+#define LTT_HAS_TSC
+
+#endif
diff -uNrp linux-2.6.14.5/include/linux/hardirq.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/hardirq.h
--- linux-2.6.14.5/include/linux/hardirq.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/hardirq.h	2006-01-22 13:01:14.000000000 +0100
@@ -87,8 +87,21 @@ extern void synchronize_irq(unsigned int
 # define synchronize_irq(irq)	barrier()
 #endif
 
+#ifdef CONFIG_IPIPE
+#define nmi_enter() \
+do { \
+    if (ipipe_current_domain == ipipe_root_domain) \
+	irq_enter(); \
+} while(0)
+#define nmi_exit() \
+do { \
+    if (ipipe_current_domain == ipipe_root_domain) \
+	sub_preempt_count(HARDIRQ_OFFSET); \
+} while(0)
+#else /* !CONFIG_IPIPE */
 #define nmi_enter()		irq_enter()
 #define nmi_exit()		sub_preempt_count(HARDIRQ_OFFSET)
+#endif /* CONFIG_IPIPE */
 
 #ifndef CONFIG_VIRT_CPU_ACCOUNTING
 static inline void account_user_vtime(struct task_struct *tsk)
